//SI5351_vfo + LCD + TX output Clk2 
//RX/TX offset = -800 Hz
//RX/TX offset -20...+20 kHz
//S1 Band, WSPR 600m ...10m

#include "si5351.h"
#include "Wire.h"
#include <LiquidCrystal.h>

Si5351 si5351;
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
 int r;
unsigned long freq = 10100;
unsigned long  freqHz;
int d[512];
int snr;
int u;

void setup(void)
{
  Serial.begin(9600);
  Serial.println("Si5351 Clockgen"); Serial.println("");
  // Start serial and initialize the Si5351
  si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 0);  
  si5351.set_correction(162100, SI5351_PLL_INPUT_XO);
  si5351.set_pll(SI5351_PLL_FIXED, SI5351_PLLA);
  si5351.set_freq(1010100000ULL,  SI5351_CLK0);
  si5351.set_freq(4040000000ULL,  SI5351_CLK1);
  si5351.set_freq(10000ULL, SI5351_CLK2);
  si5351.output_enable(SI5351_CLK0, 1);
  si5351.output_enable(SI5351_CLK1, 1);
  si5351.output_enable(SI5351_CLK2, 0);
  lcd.begin(16, 2);
  pinMode(A0, INPUT_PULLUP);
  pinMode(A1, INPUT_PULLUP);
  analogReference(INTERNAL);
}




void uac(void)
{
  long uac =0;
    for (int i=0; i <= 200; i++){
       uac = uac+ analogRead(A2);
    }
    //if (uac > 400) uac = 400;
    u=20 * log10(uac);
    Serial.println(u); 
}


void loop(void)
{
   for (int i=1; i <= 498; i++){
      int f= i * 50;
      si5351.set_freq((f+5ULL)*400000ULL, SI5351_CLK1); 
      if (i== 1) delay (500);
      delay(10);
      uac();
   }
   while ( (digitalRead(A1) == 1));
}



